
Redmine - Defect #24457

Progress of version should be calculated the same way as parent tasks

2016-11-25 14:59 - C-O L

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Roadmap Estimated time: 0.00 hour

Target version: 6.0.0   

Resolution: Fixed Affected version:  

Description

The progress of a version should be calculated the same ways as the progress of parent tasks are calculated in #23511.

Related issues:

Related to Redmine - Defect #23511: Progress of parent task should be calcula... Closed

Related to Redmine - Defect #4682: Completed version with wrong progress bar ... Closed 2010-01-28

Associated revisions

Revision 22803 - 2024-05-02 22:58 - Marius BĂLTEANU

Progress of version should be calculated the same way as parent tasks (#24457, #4682).

Revision 22804 - 2024-05-02 23:15 - Marius BĂLTEANU

Adds test for #24457.

Revision 22805 - 2024-05-02 23:35 - Marius BĂLTEANU

Fixes RuboCop offense Performance/Sum (#24457, #4682).

Revision 22806 - 2024-05-02 23:55 - Marius BĂLTEANU

Fixes RuboCop offense Layout/SpaceInsideParens (#24457).

History

#1 - 2016-11-25 15:41 - Toshi MARUYAMA

- Tracker changed from Defect to Feature

- Description updated

- Category set to Roadmap

#2 - 2016-11-25 15:41 - Toshi MARUYAMA

- Related to Defect #23511: Progress of parent task should be calculated using total estimated hours of children added

#3 - 2016-11-25 16:06 - C-O L

- File done_ratio_for_version.diff added

The progress for version is not calculated correctly.

It only uses the estimated time for issues in the version so if mixing issues with an estimated time >0.0h and issues without an estimated time then

the issues without an estimated time is not contributing to the progress at all.

It should also use the total_estimated_time instead of just estimated_time, this will make the progress correct if the parent is in the version but not the

children.

I've attached a fix that shows what I had in mind.

#4 - 2016-11-25 16:33 - Toshi MARUYAMA

- Tracker changed from Feature to Defect

#5 - 2016-11-25 16:35 - Toshi MARUYAMA

Could you add tests?
https://www.redmine.org/issues/23511


source:trunk/test/unit/version_test.rb@15993#L80

#6 - 2016-11-29 11:37 - C-O L

I'll see if I can squeeze in some time for this in the near future.

#7 - 2019-03-27 13:30 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#8 - 2019-03-31 09:05 - Marius BĂLTEANU

- Related to Defect #4682: Completed version with wrong progress bar status added

#9 - 2019-03-31 23:49 - Marius BĂLTEANU

- File 0001-Version-progress-should.patch added

- Assignee changed from Marius BĂLTEANU to Jean-Philippe Lang

- Target version set to 4.1.0

I've updated the patch posted by C-O-L and added to it a test posted by Etienne some years ago to #4682. I can confirm that this patch fixes the

related issue (#4682), but I'm not sure about the defect reported here.

From my point of view, we should take into account the total estimated hours (as the patch proposes), but I'm not sure that issues estimated at 0

hours should be treated in the same way as the issues without estimated hours.

Also, the patch generates quite a lot of queries.

I'm assigning this to 4.1.0 to clarify at least the expected behaviour. I think it could be an important fix.

#10 - 2019-09-28 00:33 - Go MAEDA

- Target version changed from 4.1.0 to 4.2.0

#11 - 2021-03-17 22:36 - Marius BĂLTEANU

- Target version changed from 4.2.0 to 5.0.0

#12 - 2022-03-27 23:17 - Marius BĂLTEANU

- Target version changed from 5.0.0 to 5.1.0

#13 - 2023-02-25 08:48 - Kamil .

@Jean-Philippe, since you are finally working on calculating progress - maybe it'll be a good idea to take also this issue into account: #6975? (since

Issue Done Ratio Both doesn't seem to be supporting new versions of Redmine anymore)

Kind regards

#14 - 2023-10-21 03:01 - Go MAEDA

- Target version changed from 5.1.0 to 6.0.0

#15 - 2024-05-02 23:01 - Marius BĂLTEANU

- Status changed from New to Closed

- Assignee changed from Jean-Philippe Lang to Marius BĂLTEANU

- Resolution set to Fixed

This is a very old issue and I've committed the fix from my previous patch in order to have the same behaviour from parent task. Regarding the

difference between issues without estimated time and issues with estimated time 0, we can track this change in another ticket if it's desired.

Files

done_ratio_for_version.diff 1.44 KB 2016-11-25 C-O L

0001-Version-progress-should.patch 2.74 KB 2019-03-31 Marius BĂLTEANU
